--- /opt/local/var/macports/sources/rsync.macports.org/release/ports//net/xymon/Portfile	2012-05-09 03:00:48.000000000 +0200
+++ Portfile	2012-07-23 14:07:06.000000000 +0200
@@ -7,7 +7,10 @@
 conflicts               xymon-server
 epoch                   1
 version                 4.3.7
-revision                1
+revision                2
+
+replaced_by             xymon-client
+
 categories              net
 platforms               darwin
 license                 GPL-2
@@ -22,119 +25,12 @@
                         Xymon was previously known as \"Hobbit\".
 
 homepage                http://www.xymon.com/
-master_sites            sourceforge:project/xymon/Xymon/${version}
 
-checksums               sha1    29339157a1a6155d134ed1ad9985391d43034ee8 \
-                        rmd160  9547eac47a5893f978cace54b5761e9cabe75941
+livecheck.type          none
 
-depends_lib             port:rrdtool \
-                        port:fping \
-                        port:pcre \
-                        port:libpng \
-                        port:openssl \
-                        port:openldap
-
-universal_variant       no
-
-patchfiles              patch-build-Makefile.rules.diff \
-                        patch-build-Makefile.Darwin.diff \
-                        patch-lib-Makefile.diff \
-                        patch-client-xymonclient-darwin.sh.diff
-
-if {"darwin" == ${os.platform} && ${os.major} > 8} {
-    set xymonuser       _xymon
-} else {
-    set xymonuser       xymon
+pre-configure {
+    ui_error "Please do not install this port since it has been replaced by 'xymon-client'."
+    return -code error
 }
-set xymongroup          ${xymonuser}
-set xytopdir            ${prefix}/lib/${name}
-set xyetcdir            ${xytopdir}/client/etc
-set xylogdir            ${xytopdir}/client/logs
-set xytmpdir            ${xytopdir}/client/tmp
-set xyvardir            ${xytopdir}/data
-set xywebdir            ${xytopdir}/web
-set xywwwdir            ${xytopdir}/www
-
-configure.cmd           ./configure.client
-configure.args-append   --rrdinclude ${prefix}/include \
-                        --rrdlib ${prefix}/lib \
-                        --pcreinclude ${prefix}/include \
-                        --pcrelib ${prefix}/lib \
-                        --sslinclude ${prefix}/include \
-                        --ssllib ${prefix}/lib \
-                        --ldapinclude ${prefix}/include \
-                        --ldaplib ${prefix}/lib \
-                        --fping ${prefix}/sbin/fping
-configure.env-append    ENABLESSL=y \
-                        XYMONUSER=${xymonuser} \
-                        XYMONTOPDIR=${xytopdir} \
-                        XYMONHOSTIP=127.0.0.1 \
-                        XYMONHOSTOS=${os.platform} \
-                        MANROOT=${prefix}/share/man \
-                        INSTALLBINDIR=${xytopdir}/client/bin \
-                        INSTALLETCDIR=${xyetcdir} \
-                        INSTALLEXTDIR=${xytopdir}/client/ext \
-                        INSTALLTMPDIR=${xytmpdir} \
-                        INSTALLWEBDIR=${xywebdir} \
-                        INSTALLWWWDIR=${xywwwdir} \
-                        XYMONVAR=${xyvardir} \
-                        CC=${configure.cc} \
-                        CXX=${configure.cxx} \
-                        CPP=${configure.cpp}
-
-build.args-append       CC=${configure.cc} \
-                        CXX=${configure.cxx} \
-                        CPP=${configure.cpp}
-
-destroot.env-append     INSTALLROOT=${destroot}
-destroot.keepdirs       ${destroot}${xytopdir} \
-                        ${destroot}${xylogdir} \
-                        ${destroot}${xytmpdir} \
-                        ${destroot}${xyvardir}/logs \
-                        ${destroot}${xyvardir} \
-                        ${destroot}${xywebdir}
-
-startupitem.create      yes
-startupitem.start       "sudo su ${xymonuser} -c \"${xytopdir}/client/runclient.sh start\""
-startupitem.stop        "sudo su ${xymonuser} -c \"${xytopdir}/client/runclient.sh stop\""
-startupitem.restart     "sudo su ${xymonuser} -c \"${xytopdir}/client/runclient.sh restart\""
-#startupitem.pidfile     auto ${xylogdir}/clientlaunch.*.pid
-startupitem.pidfile     none
-
-add_users ${xymonuser} group=${xymongroup} realname=Xymon\ User home=${xytopdir} shell=/bin/bash
-
-post-destroot {
-    xinstall -d -o ${xymonuser} -g ${xymongroup} ${destroot}${xylogdir}
-    xinstall -d -o ${xymonuser} -g ${xymongroup} ${destroot}${xytmpdir}
-    # Adding a suffix to config files
-    foreach f { clientlaunch.cfg localclient.cfg xymonclient.cfg } {
-        move ${destroot}${xyetcdir}/${f} ${destroot}${xyetcdir}/${f}.${version}
-    }
-}
-
-post-activate {
-    # If not already present we put default config files
-    foreach f { clientlaunch.cfg localclient.cfg xymonclient.cfg } {
-        if {![file exists ${xyetcdir}/${f}]} {
-            file copy ${xyetcdir}/${f}.${version} ${xyetcdir}/${f}
-        }
-    }
-}
-
-notes "\nSet your Xymon server's IP address with the following command:
-    $ sudo vi ${xyetcdir}/xymonclient.cfg
-
-If you wish your xymon client to report logfiles to your xymon server
-you need to add the user ${xymonuser} to the admin group like this:
-    $ sudo dscl . -append /Groups/admin GroupMembership ${xymonuser}
-
-You can start,stop and restart the xymon client with:
-    $ sudo -u ${xymonuser} ${xytopdir}/client/runclient.sh \[start|stop|restart\]
-"
-
-use_parallel_build  no
-
-livecheck.type      regex
-livecheck.url       http://sourceforge.net/projects/${name}/files/
-livecheck.regex     ${name}-(\[0-9.\]+)\\.tar.gz
 
+distfiles