--- Portfile.old	2012-09-19 12:34:51.000000000 +0200
+++ Portfile	2012-09-19 12:48:27.000000000 +0200
@@ -4,7 +4,7 @@
 PortSystem          1.0
 
 name                xraylib
-version             2.15.0
+version             2.16.0
 categories          science
 platforms           darwin
 maintainers         me.com:Tom.Schoonjans
@@ -16,23 +16,25 @@
                     sections (photoelectric, Compton, Rayleigh, XRF etc.), \
                     line energies, edge energies, fluorescence yields, \
                     scattering factors, refractive indices, Compton profiles \
-                    etc. Bindings exist for Perl, Python, Java, Fortran, IDL \
-                    and .NET.
+                    etc. Bindings exist for Perl, Python, Java, Fortran, IDL, \
+                    Lua and .NET.
 
 homepage            http://github.com/tschoonj/xraylib
 master_sites        https://github.com/tschoonj/xraylib/downloads/
 
-checksums           sha1   3edabe586d8f9b2cd53cd6dab1290b3135c058b5 \
-                    rmd160 1ea6febca23410506cc1569c069bf80e0615cbd5 
+checksums           rmd160  3b9a0db5fe2ae285cd364478c9e8c3d76e855069 \
+                    sha256 91ccbd25338c00027d58ee13239375926a0e106d9b883d1c927e846e035e276c 
 
 configure.args      --disable-idl \
                     --disable-fortran2003 \
                     --disable-perl \
                     --disable-python \
-                    --disable-java
+                    --disable-java \
+                    --disable-lua
 
 # to be fixed in later versions of xraylib...
 use_parallel_build  no
+configure.ccache    no
 
 variant perl description {Perl bindings} {
     configure.args-append --enable-perl
@@ -41,7 +43,7 @@
 }
 
 variant python description {Python bindings} {
-    configure.args-append --enable-python
+    configure.args-append --enable-python --enable-python-integration
     configure.args-delete --disable-python
     depends_build-append port:swig-python
 }
@@ -52,32 +54,46 @@
     depends_build-append port:swig-java
 }
 
-variant gcc43 description {build with gfortran from gcc43} conflicts gcc44 gcc45 g95 {
-    configure.args-append --enable-fortran2003
-    configure.args-delete --disable-fortran2003
-    depends_lib-append port:gcc43
-    configure.fc ${prefix}/bin/gfortran-mp-4.3
+variant lua description (Lua bindings) {
+    configure.args-append --enable-lua
+    configure.args-delete --disable-lua
+    depends_build-append port:swig-lua
+    depends_lib-append port:lua
 }
 
-variant gcc44 description {build with gfortran from gcc44} conflicts gcc43 gcc45 g95 {
+variant gcc44 description {build with gfortran from gcc44} conflicts gcc45 g95 gcc46 gcc47 {
     configure.args-append --enable-fortran2003
     configure.args-delete --disable-fortran2003
     depends_lib-append port:gcc44
     configure.fc ${prefix}/bin/gfortran-mp-4.4
 }
 
-variant gcc45 description {build with gfortran from gcc45} conflicts gcc43 gcc44 g95 {
+variant gcc45 description {build with gfortran from gcc45} conflicts gcc44 g95 gcc46 gcc47 {
     configure.args-append --enable-fortran2003
     configure.args-delete --disable-fortran2003
     depends_lib-append port:gcc45
     configure.fc ${prefix}/bin/gfortran-mp-4.5
 }
 
-variant g95 description {build with g95} conflicts gcc43 gcc44 gcc45 {
+variant g95 description {build with g95} conflicts gcc44 gcc45 gcc46 gcc47 {
     configure.args-append --enable-fortran2003
     configure.args-delete --disable-fortran2003
     depends_lib-append port:g95
     configure.fc ${prefix}/bin/g95
 }
 
+variant gcc46 description {build with gfortran from gcc46} conflicts gcc44 g95 gcc45 gcc47 {
+    configure.args-append --enable-fortran2003
+    configure.args-delete --disable-fortran2003
+    depends_lib-append port:gcc46
+    configure.fc ${prefix}/bin/gfortran-mp-4.6
+}
+
+variant gcc47 description {build with gfortran from gcc47} conflicts gcc44 g95 gcc45 gcc46 {
+    configure.args-append --enable-fortran2003
+    configure.args-delete --disable-fortran2003
+    depends_lib-append port:gcc47
+    configure.fc ${prefix}/bin/gfortran-mp-4.7
+}
+
 default_variants    +python