diff -ruN --exclude work /opt/local/var/macports/sources/rsync.macports.org/release/tarballs/ports/math/maxima/Portfile math/maxima/Portfile
--- /opt/local/var/macports/sources/rsync.macports.org/release/tarballs/ports/math/maxima/Portfile	2012-09-20 04:00:12.000000000 -0400
+++ math/maxima/Portfile	2012-09-20 14:15:02.000000000 -0400
@@ -1,10 +1,11 @@
 # -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
-# $Id: Portfile 97923 2012-09-20 07:40:42Z ciserlohn@macports.org $
+# $Id$
 
 PortSystem 1.0
 
 name            maxima
 version         5.28.0
+revision        1
 categories      math
 maintainers     mareimbrium.org:kuba
 platforms       darwin
@@ -25,7 +26,7 @@
 master_sites    sourceforge
 
 checksums       sha256  d73e925f0116ba361bf4390c80e24d4fa763f647cc1fc4cc06bbf40ceb3facda \
-                rmd160  a2d9aff1ac7e8a5464750b3b59f8b7dcedb148d5 \
+                rmd160  a2d9aff1ac7e8a5464750b3b59f8b7dcedb148d5
 
 depends_lib     port:sbcl
 depends_run     port:tk \
@@ -47,7 +48,12 @@
 }
 }
 
-variant abcl description {Use ABCL instead of SBCL for Lisp } {
+variant no_xmaxima description {Do not build xmaxima} {
+    depends_run-delete  port:tk
+    patchfiles-append   no-xmaxima.patch
+}
+
+variant abcl description {Use ABCL instead of SBCL for Lisp} {
     depends_lib-delete  port:sbcl
     depends_lib-append  port:abcl
     configure.args-delete --enable-sbcl
diff -ruN --exclude work /opt/local/var/macports/sources/rsync.macports.org/release/tarballs/ports/math/maxima/files/no-xmaxima.patch math/maxima/files/no-xmaxima.patch
--- /opt/local/var/macports/sources/rsync.macports.org/release/tarballs/ports/math/maxima/files/no-xmaxima.patch	1969-12-31 19:00:00.000000000 -0500
+++ math/maxima/files/no-xmaxima.patch	2012-09-20 09:38:34.000000000 -0400
@@ -0,0 +1,65 @@
+--- interfaces/Makefile.in.orig	2012-09-20 09:30:55.000000000 -0400
++++ interfaces/Makefile.in	2012-09-20 09:31:16.000000000 -0400
+@@ -183,8 +183,7 @@
+ target_alias = @target_alias@
+ top_builddir = @top_builddir@
+ top_srcdir = @top_srcdir@
+-SUBDIRS = emacs xmaxima
+-EXTRA_DIST = bin/xmaxima.iss
++SUBDIRS = emacs
+ all: all-recursive
+ 
+ .SUFFIXES:
+--- Makefile.in.orig	2012-09-20 09:37:06.000000000 -0400
++++ Makefile.in	2012-09-20 09:38:15.000000000 -0400
+@@ -36,9 +36,8 @@
+ DIST_COMMON = README $(am__configure_deps) $(srcdir)/Makefile.am \
+ 	$(srcdir)/Makefile.in $(srcdir)/common.mk \
+ 	$(srcdir)/maxima-local.in $(srcdir)/maxima.iss.in \
+-	$(srcdir)/maxima.spec.in $(srcdir)/xmaxima-local.in \
++	$(srcdir)/maxima.spec.in \
+ 	$(top_srcdir)/configure $(top_srcdir)/doc/man/ru/maxima.1.in \
+-	$(top_srcdir)/interfaces/xmaxima/Tkmaxima/Header.tcl.in \
+ 	AUTHORS COPYING ChangeLog INSTALL NEWS config.guess config.sub \
+ 	install-sh missing
+ subdir = .
+@@ -49,8 +48,8 @@
+ am__CONFIG_DISTCLEAN_FILES = config.status config.cache config.log \
+  configure.lineno config.status.lineno
+ mkinstalldirs = $(install_sh) -d
+-CONFIG_CLEAN_FILES = maxima-local xmaxima-local maxima.spec maxima.iss \
+-	doc/man/ru/maxima.1 interfaces/xmaxima/Tkmaxima/Header.tcl
++CONFIG_CLEAN_FILES = maxima-local maxima.spec maxima.iss \
++	doc/man/ru/maxima.1
+ SOURCES =
+ DIST_SOURCES =
+ RECURSIVE_TARGETS = all-recursive check-recursive dvi-recursive \
+@@ -212,9 +211,9 @@
+   common.mk maxima.iss.in \
+   README.lisps README.rpms README.i18n README.external \
+   INSTALL.win32 INSTALL.lisp \
+-  configure.lisp  maxima-local.in xmaxima-local.in \
++  configure.lisp  maxima-local.in \
+   macosx/Makefile macosx/Readme.txt macosx/maxima.sh macosx/script \
+-  macosx/xmaxima.sh macosx/appIcon.icns \
++  macosx/appIcon.icns \
+   ChangeLog-5.9.2 ChangeLog-5.9.3 ChangeLog-5.10.0 ChangeLog-5.11.0 \
+   ChangeLog-5.12.0 ChangeLog-5.13.0 ChangeLog-5.14.0 ChangeLog-5.15.0 \
+   ChangeLog-5.16 ChangeLog-5.17 ChangeLog-5.17-special-functions \
+@@ -282,16 +281,12 @@
+ 	cd $(srcdir) && $(ACLOCAL) $(ACLOCAL_AMFLAGS)
+ maxima-local: $(top_builddir)/config.status $(srcdir)/maxima-local.in
+ 	cd $(top_builddir) && $(SHELL) ./config.status $@
+-xmaxima-local: $(top_builddir)/config.status $(srcdir)/xmaxima-local.in
+-	cd $(top_builddir) && $(SHELL) ./config.status $@
+ maxima.spec: $(top_builddir)/config.status $(srcdir)/maxima.spec.in
+ 	cd $(top_builddir) && $(SHELL) ./config.status $@
+ maxima.iss: $(top_builddir)/config.status $(srcdir)/maxima.iss.in
+ 	cd $(top_builddir) && $(SHELL) ./config.status $@
+ doc/man/ru/maxima.1: $(top_builddir)/config.status $(top_srcdir)/doc/man/ru/maxima.1.in
+ 	cd $(top_builddir) && $(SHELL) ./config.status $@
+-interfaces/xmaxima/Tkmaxima/Header.tcl: $(top_builddir)/config.status $(top_srcdir)/interfaces/xmaxima/Tkmaxima/Header.tcl.in
+-	cd $(top_builddir) && $(SHELL) ./config.status $@
+ 
+ # This directory's subdirectories are mostly independent; you can cd
+ # into them and run `make' without going through this Makefile.