Index: devel/cmake/Portfile
===================================================================
--- devel/cmake/Portfile	(revision 99335)
+++ devel/cmake/Portfile	(working copy)
@@ -5,8 +5,7 @@
 PortGroup	muniversal 1.0
 
 name		cmake
-version		2.8.9
-revision	1
+version		2.8.10
 set branch	[join [lrange [split ${version} .] 0 1] .]
 categories	devel
 license		BSD
@@ -22,9 +21,8 @@
 master_sites	http://www.cmake.org/files/v${branch}/
 platforms	darwin freebsd
 
-checksums           md5     801f4c87f8b604f727df5bf1f05a59e7 \
-                    sha1    b96663c0757a5edfbddc410aabf7126a92131e2b \
-                    rmd160  66808a280eb8e4ae798df3283fab8bcc3f512777
+checksums           rmd160  9af9e3f26f0f3d827ef566f99050fe6a2721dd25 \
+                    sha256  a18b721c547c2ce2ea9378f2687caca4398fc348982ede799e96b26924cc9e04
 
 depends_lib-append port:libidn port:openssl
 
@@ -52,6 +50,9 @@
 patchfiles	patch-CMakeFindFrameworks.cmake.diff \
 			patch-Modules-FindQt4.cmake.diff
 
+# Add upstream patch for Darwin.cmake
+patchfiles-append patch-Modules-Platform-Darwin.cmake.diff
+
 post-patch {
 	# copy cmake init file, ready to be patched below
 	copy ${filespath}/macports.cmake ${worksrcpath}
Index: devel/cmake/files/patch-CMakeFindFrameworks.cmake.diff
===================================================================
--- devel/cmake/files/patch-CMakeFindFrameworks.cmake.diff	(revision 99335)
+++ devel/cmake/files/patch-CMakeFindFrameworks.cmake.diff	(working copy)
@@ -1,8 +1,8 @@
---- Modules/CMakeFindFrameworks.cmake	2012-05-11 11:39:53.000000000 +0200
-+++ Modules/CMakeFindFrameworks.cmake	2012-05-11 11:47:07.000000000 +0200
+--- Modules/CMakeFindFrameworks.cmake	2012-11-02 10:05:18.000000000 -0700
++++ Modules/CMakeFindFrameworks.cmake	2012-11-02 10:12:23.000000000 -0700
 @@ -20,6 +20,7 @@
-     IF(APPLE)
-       FOREACH(dir
+     if(APPLE)
+       foreach(dir
            ~/Library/Frameworks/${fwk}.framework
 +          __PREFIX__/Library/Frameworks/${fwk}.framework
            /Library/Frameworks/${fwk}.framework
Index: devel/cmake/files/patch-Modules-FindQt4.cmake.diff
===================================================================
--- devel/cmake/files/patch-Modules-FindQt4.cmake.diff	(revision 99335)
+++ devel/cmake/files/patch-Modules-FindQt4.cmake.diff	(working copy)
@@ -1,40 +1,40 @@
---- Modules/FindQt4.cmake	2012-05-11 11:39:53.000000000 +0200
-+++ Modules/FindQt4.cmake	2012-05-11 11:49:04.000000000 +0200
-@@ -526,7 +526,8 @@
-     SET(QT_MKSPECS_DIR NOTFOUND)
-     FIND_PATH(QT_MKSPECS_DIR NAMES qconfig.pri
+--- Modules/FindQt4.cmake	2012-11-02 10:05:18.000000000 -0700
++++ Modules/FindQt4.cmake	2012-11-02 10:08:45.000000000 -0700
+@@ -550,7 +550,8 @@
+     set(QT_MKSPECS_DIR NOTFOUND)
+     find_path(QT_MKSPECS_DIR NAMES qconfig.pri
        HINTS ${qt_cross_paths} ${qt_mkspecs_dirs}
 -      DOC "The location of the Qt mkspecs containing qconfig.pri")
 +      DOC "The location of the Qt mkspecs containing qconfig.pri"
 +      NO_DEFAULT_PATH)
-   ENDIF()
+   endif()
  
-   IF(EXISTS "${QT_MKSPECS_DIR}/qconfig.pri")
-@@ -620,6 +621,7 @@
-       FIND_PATH(QT_QTCORE_INCLUDE_DIR QtCore
+   if(EXISTS "${QT_MKSPECS_DIR}/qconfig.pri")
+@@ -644,6 +645,7 @@
+       find_path(QT_QTCORE_INCLUDE_DIR QtCore
                  HINTS ${qt_headers} ${QT_LIBRARY_DIR}
                  PATH_SUFFIXES QtCore qt4/QtCore
 +                NO_DEFAULT_PATH
          )
  
        # Set QT_HEADERS_DIR based on finding QtCore header
-@@ -672,7 +674,8 @@
-     endforeach(qt_cross_path)
-     FIND_PATH(QT_PLUGINS_DIR NAMES accessible imageformats sqldrivers codecs designer
+@@ -696,7 +698,8 @@
+     endforeach()
+     find_path(QT_PLUGINS_DIR NAMES accessible imageformats sqldrivers codecs designer
        HINTS ${qt_cross_paths} ${qt_plugins_dir}
 -      DOC "The location of the Qt plugins")
 +      DOC "The location of the Qt plugins"
 +      NO_DEFAULT_PATH)
-   ENDIF (QT_LIBRARY_DIR AND NOT QT_PLUGINS_DIR  OR  QT_QMAKE_CHANGED)
+   endif ()
  
    # ask qmake for the translations directory
-@@ -692,8 +695,7 @@
-       FIND_PATH(QT_IMPORTS_DIR NAMES Qt
+@@ -716,8 +719,7 @@
+       find_path(QT_IMPORTS_DIR NAMES Qt
          HINTS ${qt_cross_paths} ${qt_imports_dir}
          DOC "The location of the Qt imports"
 -        NO_CMAKE_PATH NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH
 -        NO_CMAKE_SYSTEM_PATH)
 +        NO_DEFAULT_PATH)
        mark_as_advanced(QT_IMPORTS_DIR)
-     endif(qt_imports_dir)
-   ENDIF (QT_LIBRARY_DIR AND NOT QT_IMPORTS_DIR  OR  QT_QMAKE_CHANGED)
+     endif()
+   endif ()
Index: devel/cmake/files/patch-Modules-Platform-Darwin.cmake.diff
===================================================================
--- devel/cmake/files/patch-Modules-Platform-Darwin.cmake.diff	(revision 0)
+++ devel/cmake/files/patch-Modules-Platform-Darwin.cmake.diff	(working copy)
@@ -0,0 +1,29 @@
+From: Brad King <brad.king@kitware.com>
+Date: Mon, 5 Nov 2012 15:43:46 +0000 (-0500)
+Subject: OS X: Fix default CMAKE_OSX_SYSROOT with deployment target
+X-Git-Url: http://cmake.org/gitweb?p=cmake.git;a=commitdiff_plain;h=15f5764e
+
+OS X: Fix default CMAKE_OSX_SYSROOT with deployment target
+
+Since commit 43b74793 (OS X: Further improve default CMAKE_OSX_SYSROOT
+selection, 2012-09-21) we choose a default CMAKE_OSX_SYSROOT only when
+one is needed.  However, the change forgot that we require a sysroot
+when a deployment target is requested.  Teach Darwin.cmake to choose a
+default CMAKE_OSX_SYSROOT when CMAKE_OSX_DEPLOYMENT_TARGET is set.
+
+Reported-by: Matthew Brett <matthew.brett@gmail.com>
+Reported-by: Bradley Giesbrecht <pixilla@macports.org>
+---
+
+diff --git a/Modules/Platform/Darwin.cmake b/Modules/Platform/Darwin.cmake
+index a401762..4e7e99c 100644
+--- Modules/Platform/Darwin.cmake
++++ Modules/Platform/Darwin.cmake
+@@ -107,6 +107,7 @@ elseif(NOT "x$ENV{SDKROOT}" STREQUAL "x" AND
+   # Use the value of SDKROOT from the environment.
+   set(_CMAKE_OSX_SYSROOT_DEFAULT "$ENV{SDKROOT}")
+ elseif("${CMAKE_GENERATOR}" MATCHES Xcode
++       OR CMAKE_OSX_DEPLOYMENT_TARGET
+        OR CMAKE_OSX_ARCHITECTURES MATCHES "[^;]"
+        OR NOT EXISTS "/usr/include/sys/types.h")
+   # Find installed SDKs in either Xcode-4.3+ or pre-4.3 SDKs directory.
Index: _resources/port1.0/group/cmake-1.0.tcl
===================================================================
--- _resources/port1.0/group/cmake-1.0.tcl	(revision 99335)
+++ _resources/port1.0/group/cmake-1.0.tcl	(working copy)
@@ -64,8 +64,6 @@
         -DCMAKE_OSX_ARCHITECTURES=\"[join ${configure.universal_archs} \;]\"
     if {${configure.sdkroot} != ""} {
         configure.args-append -DCMAKE_OSX_SYSROOT="${configure.sdkroot}"
-    } else {
-        configure.args-append -DCMAKE_OSX_SYSROOT=/
     }
 }
 