Index: Portfile
===================================================================
--- Portfile	(revision 100362)
+++ Portfile	(working copy)
@@ -1,148 +1,13 @@
 # $Id$
 
-PortSystem			1.0
+PortSystem      1.0
+PortGroup       crossbinutils 1.0
 
-name				i386-elf-binutils
-version				2.20
+crossbinutils.setup i386-elf 2.23.1
+revision        1
+maintainers     gmail.com:jinksys
 
-# Parameters for this port.
-set crossgcc-target i386-elf
+checksums       rmd160  7ccebcdd634ba795fbcd5d7033d1b96db6edecc2 \
+                sha256  2ab2e5b03e086d12c6295f831adad46b3e1410a3a234933a2e8fac66cb2e7a19
 
-description			FSF Binutils for i386-elf cross development
-long_description	Free Software Foundation development toolchain ("binutils") for \
-					i386-elf cross development.
-platforms			darwin
-categories			cross devel
-license				GPL-3+
-maintainers			gmail.com:jinksys
-homepage			http://www.gnu.org/software/binutils/binutils.html
-master_sites		ftp://ftp.kernel.org/pub/linux/devel/binutils/ \
-					http://ftp.kernel.org/pub/linux/devel/binutils/
-distname			binutils-${version}
-use_bzip2			yes
-checksums			md5    ee2d3e996e9a2d669808713360fa96f8 \
-					sha1   747e7b4d94bce46587236dc5f428e5b412a590dc \
-					rmd160 284074e2453e517d036ffce2c0f3d56439e2e5c0
-
-depends_lib			port:gettext
-
-# All cross ports violate the mtree layout.
-destroot.violate_mtree	yes
-
-# Download everything to binutils/
-dist_subdir			binutils
-
-if {${os.platform} == "darwin" && ${os.major} >= 10} {
-	patchfiles-append	patch-binutils__strings.c
-}
-# i386-dis.c:6670:21: fatal error: parser recursion limit reached, program too complex
-if {${configure.compiler} == "clang"} {
-    configure.compiler llvm-gcc-4.2
-}
-
-# Build in a different directory, as advised in the README file.
-pre-configure   	{ system "cd ${workpath} && mkdir -p build"}
-configure.dir   	${workpath}/build
-configure.cmd   	${worksrcpath}/configure
-configure.args  	--infodir='${prefix}/share/info' --target=${crossgcc-target} \
-					--program-prefix=${crossgcc-target}- --mandir='${prefix}/share/man' \
-					--disable-werror
-if {${os.platform} == "darwin" && ($build_arch == "x86_64" || $build_arch == "ppc64")} {
-    configure.args-append --build=${build_arch}-apple-${os.platform}${os.version}
-}
-build.dir       	${workpath}/build
-					
-# We don't want the etc module.
-post-extract {
-	system "rm -rf ${worksrcpath}/etc"
-}
-
-post-patch {
-	namespace eval crossgcc {}
-
-	# Fix the info pages and related stuff.
-	#
-	# path: path to the doc directory (e.g. gas/doc/)
-	# makefile: path to Makefile.in (e.g. gas/doc/Makefile.in)
-	# name: name of the info page (e.g. as)
-	# suffix: suffix of the souce page (texinfo or texi)
-	proc crossgcc::fixinfo { path makefile name suffix } {
-		global crossgcc-target worksrcpath
-
-		# Fix the source
-		reinplace "s|setfilename ${name}.info|setfilename ${crossgcc-target}-${name}.info|g" \
-			${worksrcpath}/${path}/${name}.${suffix}
-		reinplace "s|(${name})|(${crossgcc-target}-${name})|g" \
-			${worksrcpath}/${path}/${name}.${suffix}
-		reinplace "s|@file{${name}}|@file{${crossgcc-target}-${name}}|g" \
-			${worksrcpath}/${path}/${name}.${suffix}
-		
-		# Fix the Makefile
-		reinplace "s|${name}.info|${crossgcc-target}-${name}.info|g" \
-			${worksrcpath}/${makefile}
-		reinplace "s|${name}.${suffix}|${crossgcc-target}-${name}.${suffix}|g" \
-			${worksrcpath}/${makefile}
-		
-		# Rename the source
-		file rename ${worksrcpath}/${path}/${name}.${suffix} \
-			${worksrcpath}/${path}/${crossgcc-target}-${name}.${suffix}
-		
-		# Fix install-info's dir.
-		# (note: this may be effectless if there was no info dir to be fixed)
-		reinplace "s|--info-dir=\$(DESTDIR)\$(infodir)|--dir-file=\$(DESTDIR)\$(infodir)/${crossgcc-target}-dir|g" \
-			"${worksrcpath}/${makefile}"
-	}
-
-	# Fix the gettext files and related stuff.
-	#
-	# module: name of the module (e.g. gas)
-	proc crossgcc::fixgettext { module } {
-		global crossgcc-target worksrcpath
-
-		if { [ file exists "${worksrcpath}/${module}/Makefile.in" ] } {
-			reinplace "s|@PACKAGE@|${crossgcc-target}-@PACKAGE@|g" \
-				"${worksrcpath}/${module}/Makefile.in"
-		}
-		if { [ file exists "${worksrcpath}/${module}/doc/Makefile.in" ] } {
-			reinplace "s|@PACKAGE@|${crossgcc-target}-@PACKAGE@|g" \
-				"${worksrcpath}/${module}/doc/Makefile.in"
-		}
-		if { [ file exists "${worksrcpath}/${module}/po/Make-in" ] } {
-			reinplace "s|@PACKAGE@|${crossgcc-target}-@PACKAGE@|g" \
-				"${worksrcpath}/${module}/po/Make-in"
-		}
-	}
-
-	# gas/doc/as.texinfo
-	crossgcc::fixinfo gas/doc/ gas/doc/Makefile.in as texinfo
-
-	# bfd/doc/bfd.texinfo
-	crossgcc::fixinfo bfd/doc/ bfd/doc/Makefile.in bfd texinfo
-
-	# binutils/doc/binutils.texi
-	crossgcc::fixinfo binutils/doc/ binutils/doc/Makefile.in binutils texi
-
-	# gprof/gprof.texi
-	crossgcc::fixinfo gprof/ gprof/Makefile.in gprof texi
-
-	# ld/ld.texinfo
-	crossgcc::fixinfo ld/ ld/Makefile.in ld texinfo
-	
-	# gettext stuff.
-	crossgcc::fixgettext bfd
-	crossgcc::fixgettext binutils
-	crossgcc::fixgettext gas
-	crossgcc::fixgettext gprof
-	crossgcc::fixgettext ld
-	crossgcc::fixgettext opcodes
-}
-
-post-destroot {
-	# Installing (host) libiberty was a mistake.
-	foreach f [glob -directory "${destroot}${prefix}/lib" libiberty.a */libiberty.a] {
-        file delete $f
-    }
-}
-
-livecheck.type	freecode
-livecheck.name	binutils
+configure.args-append --disable-werror